{ pkgs ? import <nixpkgs> { }
, callPackage ? pkgs.callPackage
, stdenv ? pkgs.stdenv
, fetchgit ? pkgs.fetchgit
, name ? "brownpaper"
, src ? (builtins.filterSource (path: type: baseNameOf path != "target") ./.)
}:
let
  crate2nix_tools = import "${fetchgit { url = "https://github.com/kolloch/crate2nix.git"; rev = "adecff03c53b87255b3299f5a5787327342a69b2"; sha256 = "0l10yqa3gq73fc4xc977vb9zk5jlp70xiz5qd9c1vq873yqk1c7g"; }}/tools.nix" { inherit pkgs; };
  overrides = with pkgs; let
    clang = llvmPackages_10.clang;
    libclang = llvmPackages_10.libclang;
  in
  defaultCrateOverrides // rec {
    nettle-sys = attrs: rec {
      nativeBuildInputs = [ clang pkg-config ];
      buildInputs = [ nettle ];
      LIBCLANG_PATH = "${libclang}/lib";
    };
    brownpaper = attrs: {
      buildInputs = [ gmp ];
    };
  };
  client = pkgs.writeShellScriptBin "brownpaper" ''
    PATH=${pkgs.bash}/bin/:${pkgs.gnupg}/bin/:${pkgs.curl}/bin/:$PATH ${./bp.sh} "$@"
  '';
in
{ server = callPackage (crate2nix_tools.generatedCargoNix { inherit name src; }) { inherit pkgs; defaultCrateOverrides = overrides; };  inherit client; }
